**Chapter 3: Specification of Generalized Linear Models (ch3data.sav)

**Specifying the Model
**Model 1.1: Tables 3.6, 3.8, 3.9, 3.14  (ch3data.sav) 

* Generalized Linear Models.
GENLIN readprof (REFERENCE=FIRST)
  /MODEL INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=KERNEL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED) HISTORY(1).


**Adding Gender to the Model
**Model 1.2: Tables 3.11, 3.13  (ch3data.sav)

* Generalized Linear Models.
GENLIN readprof (REFERENCE=FIRST) BY female (ORDER=DESCENDING)
  /MODEL female INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=KERNEL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED) HISTORY(1).


**Adding Additional Background Predictors
**Model 1.3: Tables 3.16, 3.17  (ch3data.sav)

* Generalized Linear Models.
GENLIN readprof (REFERENCE=FIRST) BY female lowses minor (ORDER=DESCENDING)
  /MODEL female lowses minor INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=KERNEL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED) HISTORY(1).

