**Chapter 7: Two-Level Models with Count Data (ch7data1.sav, ch7data2.sav)

**Preliminary Single-Level Models
**Model 1.1: Tables 7.3, 7.4, 7.5  (ch7data1.sav)

* Generalized Linear Models.
GENLIN fail WITH lowses male math age
  /MODEL lowses male math age INTERCEPT=YES
 DISTRIBUTION=POISSON LINK=LOG
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).

**Preliminary Single-Level Models**
**Model 1.2:  Tables 7.6, 7.7  (ch7data1.sav)

* Generalized Linear Models.
GENLIN fail WITH lowses male gmmath gmage
  /MODEL lowses male gmmath gmage INTERCEPT=YES
 DISTRIBUTION=POISSON LINK=LOG
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).

 
**Tables 7.10, 7.11: Parameter Estimates with Zmath , and Goodness of Fit (ch7data1-verB.sav)

* Generalized Linear Models.
GENLIN fail WITH lowses male gmage zmath
  /MODEL lowses male gmage zmath INTERCEPT=YES
 DISTRIBUTION=POISSON LINK=LOG
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).

**Considering Possible Overdispersion
**Model 1.3: Tables 7.12, 7.13 (Negative binomial distribution, log link, specify value "0"; ch7data1.sav)

* Generalized Linear Models.
GENLIN fail WITH lowses male gmmath gmage
  /MODEL lowses male gmmath gmage INTERCEPT=YES
 DISTRIBUTION=NEGBIN(0) LINK=LOG
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).

**Model 1.4: Tables 7.14, 7.15 (Negative binomial distribution, log link, specify value "1"; ch7data1.sav)

* Generalized Linear Models.
GENLIN fail WITH lowses male gmmath gmage
  /MODEL lowses male gmmath gmage INTERCEPT=YES
 DISTRIBUTION=NEGBIN(1) LINK=LOG
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).

**Model 1.5: Table 7.16 (Negative binomial distribution, log link, estimate value; ch7data1.sav)

* Generalized Linear Models.
GENLIN fail WITH lowses male gmmath gmage
  /MODEL lowses male gmmath gmage INTERCEPT=YES
 DISTRIBUTION=NEGBIN(MLE) LINK=LOG
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).

 
**Estimating Two-Level Count Data with GENLIN MIXED
**Model 2.1: Table 7.18  (Poisson distribution, log link; ch7data1.sav)


*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=nschcode
  /FIELDS TARGET=fail TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=POISSON LINK=LOG
  /FIXED  EFFECTS=lowses male gmmath gmage USE_INTERCEPT=TRUE
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Unconditional Model
**Model 2.2: Tables 7.19, 7.20, 7.21 (ch7data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=nschcode
  /FIELDS TARGET=fail TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=POISSON LINK=LOG
  /FIXED USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=nschcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.


**Within-Schools Model
**Model 2.3: Tables 7.22, 7.23, 7.24  (ch7data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=nschcode
  /FIELDS TARGET=fail TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=POISSON LINK=LOG
  /FIXED  EFFECTS=lowses male gmmath gmage USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=nschcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.


**Examining Whether the Negative Binomial Distribution is a Better Choice
**Model 2.4: Tables 7.25, 7.26 (ch7data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=nschcode
  /FIELDS TARGET=fail TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=NEGATIVE_BINOMIAL LINK=LOG
  /FIXED  EFFECTS=lowses male gmmath gmage USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=nschcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Does the SES-Failure Slope Vary Across Schools?
**Model 2.5: Tables 7.28, 7.29  (ch7data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=nschcode
  /FIELDS TARGET=fail TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=NEGATIVE_BINOMIAL LINK=LOG
  /FIXED  EFFECTS=lowses male gmmath gmage USE_INTERCEPT=TRUE
  /RANDOM EFFECTS=lowses USE_INTERCEPT=TRUE SUBJECTS=nschcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Modeling Variability at Level 2
**Model 2.6: Tables 7.30, 7.31, 7.32  (ch7data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=nschcode
  /FIELDS TARGET=fail TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=NEGATIVE_BINOMIAL LINK=LOG
  /FIXED  EFFECTS=lowses male gmmath gmage gmAvgYearsExp gmlicensedper USE_INTERCEPT=TRUE
  /RANDOM EFFECTS=lowses USE_INTERCEPT=TRUE SUBJECTS=nschcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Adding the Cross-Level Interactions
**Model 2.7: Tables 7.33, 7.34, 7.35  (ch7data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=nschcode
  /FIELDS TARGET=fail TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=NEGATIVE_BINOMIAL LINK=LOG
  /FIXED  EFFECTS=lowses male gmmath gmage gmAvgYearsExp gmlicensedper lowses*gmAvgYearsExp 
    lowses*gmlicensedper USE_INTERCEPT=TRUE
  /RANDOM EFFECTS=lowses USE_INTERCEPT=TRUE SUBJECTS=nschcode COVARIANCE_TYPE=UNSTRUCTURED 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

 
**Specifying a Single-Level Model 
**Model 3.1: Table 7.38  (ch7data2.sav)

* Generalized Linear Models.
GENLIN fail WITH ses male gmmath gmgpa twoyear
  /MODEL ses male gmmath gmgpa twoyear INTERCEPT=YES
 DISTRIBUTION=POISSON LINK=LOG
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).

**Adding the Offset
**Model 3.2: Table 7.39  (ch7data2.sav)

* Generalized Linear Models.
GENLIN fail WITH ses male gmmath gmgpa twoyear
  /MODEL ses male gmmath gmgpa twoyear INTERCEPT=YES OFFSET=Lnsemester
 DISTRIBUTION=POISSON LINK=LOG
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).


**Adding the Offset (Changing the Scale Parameter Method to Pearson chi-square)
**Model 3.3: Tables 7.40, 7.41  (ch7data2.sav)

* Generalized Linear Models.
GENLIN fail WITH ses male gmmath gmgpa twoyear
  /MODEL ses male gmmath gmgpa twoyear INTERCEPT=YES OFFSET=Lnsemester
 DISTRIBUTION=POISSON LINK=LOG
  /CRITERIA METHOD=FISHER(1) SCALE=PEARSON COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).


**Adding the Offset (Adding lnsemester into model as covariate)
**Model 3.4: Table 7.42  (ch7data2.sav)

* Generalized Linear Models.
GENLIN fail WITH ses male gmmath gmgpa twoyear Lnsemester
  /MODEL Lnsemester ses male gmmath gmgpa twoyear INTERCEPT=YES
 DISTRIBUTION=POISSON LINK=LOG
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).

**Estimating the Model with GENLIN MIXED
**Model 4.1: Tables 7.43, 7.44  (ch7data2.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=nschcode
  /FIELDS TARGET=fail TRIALS=NONE OFFSET=FIELD(Lnsemester)
  /TARGET_OPTIONS DISTRIBUTION=POISSON LINK=LOG
  /FIXED  EFFECTS=ses male gmmath gmgpa twoyear gmacadprocess gminstqual USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=nschcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.


**Model 4.2: Table 7.46  (Probability of failing one or more courses; ch7data2.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=nschcode
  /FIELDS TARGET=fail TRIALS=NONE OFFSET=FIELD(Lnsemester)
  /TARGET_OPTIONS DISTRIBUTION=NEGATIVE_BINOMIAL LINK=LOG
  /FIXED  EFFECTS=ses male gmmath gmgpa twoyear gmacadprocess gminstqual USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=nschcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD. 


